Subject: Re: [RFC] net: dsa: qca8k: CPU port broken with commit 5502b218e001 ("net: phy: use phy_resolve_aneg_linkmode in genphy_read_status")

From: Andrew Lunn <[email-masked]>
Date: Thu, 21 Feb 2019 01:38:55 +0100

On Wed, Feb 20, 2019 at 04:02:32PM +0100, Michal Vokáč wrote:
> Hi,
> 
> Another issue in a row with networking on imx6dl-yapp4 platform [1]
> that uses QCA8334 Ethernet switch.
> 
> Very recently, with Vinod and Andrew, we solved an issue with
> RGMII_ID mode by patch[2][3]. I tested those with next-20190215
> and it worked just fine.
> 
> The patch[2] was merged into next-20190220 so I tested the latest version.
> Now the cpu port does not work again. I tracked it down to this commit
> 5502b218e001 ("net: phy: use phy_resolve_aneg_linkmode in
> genphy_read_status") [4]
> 
> If I revert the offending commit, cpu port works fine. I suspect the
> problem is on the qca8k driver side but I am not really sure.
> AFAICT autonegotiation is not available on the QCA833x cpu port (MAC0).
> 
> Any ideas what may be the root cause of the problem?

Hi Michal

I would suggest taking a look at dsa_port_fixed_link_register_of().

It might be a bit more state needs initialising before calling
genphy_read_status()?

	Andrew